import QtQuick 2.0
import org.ukui.appwidget.private 1.0 as UKUIAppWidget

Item {
    id:controlroot
    UKUIAppWidget.Connection {
        id:appwidget
    }
    signal qmldefineeventchangedsignal(string eventname, string widgetname, var value);
    signal qmlclickedsignal(string widgetname, var value);
    signal update();
    signal gsettingUpdate(string key, var value);
    property string appname
    property string username
    property var datavalue
    Component.onCompleted: {
        appwidget.updatesignal.connect(controlroot.qmlUpdate)
        qmlclickedsignal.connect(appwidget.onClickedEvent)
        qmldefineeventchangedsignal.connect(appwidget.onDefineEvent)

        appwidget.gsettingChanged.connect(controlroot.gsettingChanged)
    }
    function qmlUpdate() {
        datavalue = appwidget.getData();
        update();
    }
    function register(appname, username)
    {
        appwidget.registerDbus(appname, username);
        console.log(" QML AppWidget register dbus");
    }
    function creatGsetting(gsettingname)
    {
        console.log(" QML AppWidget creatGsetting", gsettingname);
        if(appwidget.creatGsetting(gsettingname)) {
            console.log(" QML AppWidget register gsetting successful");
        }else {
            console.log(" QML AppWidget register gsetting fail");
        }
    }
    function deleteGsetting(gsettingname)
    {
        console.log(" QML AppWidget deleteGsetting", gsettingname);
        if(appwidget.deleteGsetting(gsettingname)) {
            console.log(" QML AppWidget delete gsetting successful");
        }else {
            console.log(" QML AppWidget delete gsetting fail");
        }
    }
    function getGsettingValue(gsettingname, key)
    {
        console.log(" QML AppWidget getGsettingValue", gsettingname, key, appwidget.getGsettingValue(gsettingname, key));
        return appwidget.getGsettingValue(gsettingname, key);
    }
    function gsettingChanged(key, value) {
        console.log(" QML AppWidget gsettingChanged", key,value)
        gsettingUpdate(key, value);
    }
}
